function [tickCoeffs] = calcTickCoeffs(fileName)
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here

load(fileName,'-mat');

tickCoeffs = struct;

tickCoeffs.INXX = struct;
[tickCoeffs.INXX.coeffs, tickCoeffs.INXX.uncertainty, tickCoeffs.INXX.n] = estimateCoeff(ticks.INXXP2, ticks.INXXN2, 'Inboard DAC X on ADC X', 0);

tickCoeffs.INXY = struct;
[tickCoeffs.INXY.coeffs, tickCoeffs.INXY.uncertainty, tickCoeffs.INXY.n] = estimateCoeff(ticks.INXYP2, ticks.INXYN2, 'Inboard DAC X on ADC Y', 0);

tickCoeffs.INXZ = struct;
[tickCoeffs.INXZ.coeffs, tickCoeffs.INXZ.uncertainty, tickCoeffs.INXZ.n] = estimateCoeff(ticks.INXZP2, ticks.INXZN2, 'Inboard DAC X on ADC Z', 0);


tickCoeffs.INYX = struct;
[tickCoeffs.INYX.coeffs, tickCoeffs.INYX.uncertainty, tickCoeffs.INYX.n] = estimateCoeff(ticks.INYXP2, ticks.INYXN2, 'Inboard DAC Y on ADC X', 0);

tickCoeffs.INYY = struct;
[tickCoeffs.INYY.coeffs, tickCoeffs.INYY.uncertainty, tickCoeffs.INYY.n] = estimateCoeff(ticks.INYYP2, ticks.INYYN2, 'Inboard DAC Y on ADC Y', 0);

tickCoeffs.INYZ = struct;
[tickCoeffs.INYZ.coeffs, tickCoeffs.INYZ.uncertainty, tickCoeffs.INYZ.n] = estimateCoeff(ticks.INYZP2, ticks.INYZN2, 'Inboard DAC Y on ADC Z', 0);


tickCoeffs.INZX = struct;
[tickCoeffs.INZX.coeffs, tickCoeffs.INZX.uncertainty, tickCoeffs.INZX.n] = estimateCoeff(ticks.INZXP2, ticks.INZXN2, 'Inboard DAC Z on ADC X', 0);

tickCoeffs.INZY = struct;
[tickCoeffs.INZY.coeffs, tickCoeffs.INZY.uncertainty, tickCoeffs.INZY.n] = estimateCoeff(ticks.INZYP2, ticks.INZYN2, 'Inboard DAC Z on ADC Y', 0);

tickCoeffs.INZZ = struct;
[tickCoeffs.INZZ.coeffs, tickCoeffs.INZZ.uncertainty, tickCoeffs.INZZ.n] = estimateCoeff(ticks.INZZP2, ticks.INZZN2, 'Inboard DAC Z on ADC Z', 0);




tickCoeffs.OUTXX = struct;
[tickCoeffs.OUTXX.coeffs, tickCoeffs.OUTXX.uncertainty, tickCoeffs.OUTXX.n] = estimateCoeff(ticks.OUTXXP2, ticks.OUTXXN2, 'Outboard DAC X on ADC X', 0);

tickCoeffs.OUTXY = struct;
[tickCoeffs.OUTXY.coeffs, tickCoeffs.OUTXY.uncertainty, tickCoeffs.OUTXY.n] = estimateCoeff(ticks.OUTXYP2, ticks.OUTXYN2, 'Outboard DAC X on ADC Y', 0);

tickCoeffs.OUTXZ = struct;
[tickCoeffs.OUTXZ.coeffs, tickCoeffs.OUTXZ.uncertainty, tickCoeffs.OUTXZ.n] = estimateCoeff(ticks.OUTXZP2, ticks.OUTXZN2, 'Outboard DAC X on ADC Z', 0);


tickCoeffs.OUTYX = struct;
[tickCoeffs.OUTYX.coeffs, tickCoeffs.OUTYX.uncertainty, tickCoeffs.OUTYX.n] = estimateCoeff(ticks.OUTYXP2, ticks.OUTYXN2, 'Outboard DAC Y on ADC X', 0);

tickCoeffs.OUTYY = struct;
[tickCoeffs.OUTYY.coeffs, tickCoeffs.OUTYY.uncertainty, tickCoeffs.OUTYY.n] = estimateCoeff(ticks.OUTYYP2, ticks.OUTYYN2, 'Outboard DAC Y on ADC Y', 0);

tickCoeffs.OUTYZ = struct;
[tickCoeffs.OUTYZ.coeffs, tickCoeffs.OUTYZ.uncertainty, tickCoeffs.OUTYZ.n] = estimateCoeff(ticks.OUTYZP2, ticks.OUTYZN2, 'Outboard DAC Y on ADC Z', 0);


tickCoeffs.OUTZX = struct;
[tickCoeffs.OUTZX.coeffs, tickCoeffs.OUTZX.uncertainty, tickCoeffs.OUTZX.n] = estimateCoeff(ticks.OUTZXP2, ticks.OUTZXN2, 'Outboard DAC Z on ADC X', 0);

tickCoeffs.OUTZY = struct;
[tickCoeffs.OUTZY.coeffs, tickCoeffs.OUTZY.uncertainty, tickCoeffs.OUTZY.n] = estimateCoeff(ticks.OUTZYP2, ticks.OUTZYN2, 'Outboard DAC Z on ADC Y', 0);

tickCoeffs.OUTZZ = struct;
[tickCoeffs.OUTZZ.coeffs, tickCoeffs.OUTZZ.uncertainty, tickCoeffs.OUTZZ.n] = estimateCoeff(ticks.OUTZZP2, ticks.OUTZZN2, 'Outboard DAC Z on ADC Z', 0);

tickCoeffsFileName = strcat(fileName,'.coeffs');

save(tickCoeffsFileName, 'tickCoeffs');

hat=1 ;
end

