function [tickCoeffs] = calcTickCoeffsTempDep(fileName)
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here

load(fileName,'-mat');

tempInd = [-40 -30 -20 -10 -8 -6 -4 -2 0 2 4 6 8 10 20 30 40];
n = numel(tempInd)-1;

tickCoeffs(n) = struct;

for i = 1:n

    fprintf('Fitting temperatures from %d to %d.\n', tempInd(i), tempInd(i+1));
    
    tickCoeffs(i).INXX = struct;
    [tickCoeffs(i).INXX.coeffs, tickCoeffs(i).INXX.uncertainty, tickCoeffs(i).INXX.n] = ....
        estimateCoeffByTemp(ticks.INXXP2, ticks.INXXN2, 'Inboard DAC X on ADC X', 0, tempInd(i), tempInd(i+1) );

    
    tickCoeffs(i).INXX = struct;
    [tickCoeffs(i).INXX.coeffs, tickCoeffs(i).INXX.uncertainty, tickCoeffs(i).INXX.n] = ...
        estimateCoeffByTemp(ticks.INXXP2, ticks.INXXN2, 'Inboard DAC X on ADC X', 0, tempInd(i), tempInd(i+1));

    tickCoeffs(i).INXY = struct;
    [tickCoeffs(i).INXY.coeffs, tickCoeffs(i).INXY.uncertainty, tickCoeffs(i).INXY.n] = ...
        estimateCoeffByTemp(ticks.INXYP2, ticks.INXYN2, 'Inboard DAC X on ADC Y', 0, tempInd(i), tempInd(i+1));

    tickCoeffs(i).INXZ = struct;
    [tickCoeffs(i).INXZ.coeffs, tickCoeffs(i).INXZ.uncertainty, tickCoeffs(i).INXZ.n] = ...
        estimateCoeffByTemp(ticks.INXZP2, ticks.INXZN2, 'Inboard DAC X on ADC Z', 0, tempInd(i), tempInd(i+1));


    tickCoeffs(i).INYX = struct;
    [tickCoeffs(i).INYX.coeffs, tickCoeffs(i).INYX.uncertainty, tickCoeffs(i).INYX.n] = ...
        estimateCoeffByTemp(ticks.INYXP2, ticks.INYXN2, 'Inboard DAC Y on ADC X', 0, tempInd(i), tempInd(i+1));

    tickCoeffs(i).INYY = struct;
    [tickCoeffs(i).INYY.coeffs, tickCoeffs(i).INYY.uncertainty, tickCoeffs(i).INYY.n] = ...
        estimateCoeffByTemp(ticks.INYYP2, ticks.INYYN2, 'Inboard DAC Y on ADC Y', 0, tempInd(i), tempInd(i+1));

    tickCoeffs(i).INYZ = struct;
    [tickCoeffs(i).INYZ.coeffs, tickCoeffs(i).INYZ.uncertainty, tickCoeffs(i).INYZ.n] = ...
        estimateCoeffByTemp(ticks.INYZP2, ticks.INYZN2, 'Inboard DAC Y on ADC Z', 0, tempInd(i), tempInd(i+1));


    tickCoeffs(i).INZX = struct;
    [tickCoeffs(i).INZX.coeffs, tickCoeffs(i).INZX.uncertainty, tickCoeffs(i).INZX.n] = ...
        estimateCoeffByTemp(ticks.INZXP2, ticks.INZXN2, 'Inboard DAC Z on ADC X', 0, tempInd(i), tempInd(i+1));

    tickCoeffs(i).INZY = struct;
    [tickCoeffs(i).INZY.coeffs, tickCoeffs(i).INZY.uncertainty, tickCoeffs(i).INZY.n] = ...
        estimateCoeffByTemp(ticks.INZYP2, ticks.INZYN2, 'Inboard DAC Z on ADC Y', 0, tempInd(i), tempInd(i+1));

    tickCoeffs(i).INZZ = struct;
    [tickCoeffs(i).INZZ.coeffs, tickCoeffs(i).INZZ.uncertainty, tickCoeffs(i).INZZ.n] = ...
        estimateCoeffByTemp(ticks.INZZP2, ticks.INZZN2, 'Inboard DAC Z on ADC Z', 0, tempInd(i), tempInd(i+1));




    tickCoeffs(i).OUTXX = struct;
    [tickCoeffs(i).OUTXX.coeffs, tickCoeffs(i).OUTXX.uncertainty, tickCoeffs(i).OUTXX.n] = ...
        estimateCoeffByTemp(ticks.OUTXXP2, ticks.OUTXXN2, 'Outboard DAC X on ADC X', 0, tempInd(i), tempInd(i+1));

    tickCoeffs(i).OUTXY = struct;
    [tickCoeffs(i).OUTXY.coeffs, tickCoeffs(i).OUTXY.uncertainty, tickCoeffs(i).OUTXY.n] = ...
        estimateCoeffByTemp(ticks.OUTXYP2, ticks.OUTXYN2, 'Outboard DAC X on ADC Y', 0, tempInd(i), tempInd(i+1));

    tickCoeffs(i).OUTXZ = struct;
    [tickCoeffs(i).OUTXZ.coeffs, tickCoeffs(i).OUTXZ.uncertainty, tickCoeffs(i).OUTXZ.n] = ...
        estimateCoeffByTemp(ticks.OUTXZP2, ticks.OUTXZN2, 'Outboard DAC X on ADC Z', 0, tempInd(i), tempInd(i+1));


    tickCoeffs(i).OUTYX = struct;
    [tickCoeffs(i).OUTYX.coeffs, tickCoeffs(i).OUTYX.uncertainty, tickCoeffs(i).OUTYX.n] = ...
        estimateCoeffByTemp(ticks.OUTYXP2, ticks.OUTYXN2, 'Outboard DAC Y on ADC X', 0, tempInd(i), tempInd(i+1));

    tickCoeffs(i).OUTYY = struct;
    [tickCoeffs(i).OUTYY.coeffs, tickCoeffs(i).OUTYY.uncertainty, tickCoeffs(i).OUTYY.n] = ...
        estimateCoeffByTemp(ticks.OUTYYP2, ticks.OUTYYN2, 'Outboard DAC Y on ADC Y', 0, tempInd(i), tempInd(i+1));

    tickCoeffs(i).OUTYZ = struct;
    [tickCoeffs(i).OUTYZ.coeffs, tickCoeffs(i).OUTYZ.uncertainty, tickCoeffs(i).OUTYZ.n] = ...
        estimateCoeffByTemp(ticks.OUTYZP2, ticks.OUTYZN2, 'Outboard DAC Y on ADC Z', 0, tempInd(i), tempInd(i+1));


    tickCoeffs(i).OUTZX = struct;
    [tickCoeffs(i).OUTZX.coeffs, tickCoeffs(i).OUTZX.uncertainty, tickCoeffs(i).OUTZX.n] = ...
        estimateCoeffByTemp(ticks.OUTZXP2, ticks.OUTZXN2, 'Outboard DAC Z on ADC X', 0, tempInd(i), tempInd(i+1));

    tickCoeffs(i).OUTZY = struct;
    [tickCoeffs(i).OUTZY.coeffs, tickCoeffs(i).OUTZY.uncertainty, tickCoeffs(i).OUTZY.n] = ...
        estimateCoeffByTemp(ticks.OUTZYP2, ticks.OUTZYN2, 'Outboard DAC Z on ADC Y', 0, tempInd(i), tempInd(i+1));

    tickCoeffs(i).OUTZZ = struct;
    [tickCoeffs(i).OUTZZ.coeffs, tickCoeffs(i).OUTZZ.uncertainty, tickCoeffs(i).OUTZZ.n] = ...
        estimateCoeffByTemp(ticks.OUTZZP2, ticks.OUTZZN2, 'Outboard DAC Z on ADC Z', 0, tempInd(i), tempInd(i+1));

end

tickCoeffsFileName = strcat(fileName,'.coeffsTempDep');

save(tickCoeffsFileName, 'tickCoeffs', 'tempInd');


hat=1 ;
end

