function [outputArray] = getTicks(DAC, ADC, DACAlt1, DACAlt2, DACdelta, time, hk_Tsensor, hk_Tebox, hk_time, titleStr )
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

span = 16;
ticDur = 16;

k = find( DAC(1:end-1) == DAC(2:end) + DACdelta);
j = k( (k > span) & (k < numel(DAC)-span-ticDur-1) );

tickArray = nan(numel(j),ticDur+2);
stepArray = nan(numel(j),ticDur+2);
timeArray = NaT(1,numel(j));

tickCount = 1;
for i = 1:numel(j)

    %% Look for an interval when only the active DAC is changing
    
    if ~all(DAC(j(i)+1:j(i)+ticDur+span) == DAC(j(i)+1))
        continue
    end

    if ~all(DAC(j(i)-1:j(i)-span) == DAC(j(i)-1))
        continue
    end
    
    if ~all(DACAlt1(j(i)-span:j(i)+ticDur+span) == DACAlt1(j(i)))
        continue
    end
    
    if ~all(DACAlt2(j(i)-span:j(i)+ticDur+span) == DACAlt2(j(i)))
        continue
    end
    
    if ~all(isfinite(DACAlt1(j(i)-span:j(i)+ticDur+span)) )
        continue
    end
    
    if ~all(isfinite(DACAlt1(j(i)-span:j(i)+ticDur+span)) )
        continue
    end
    
    if ~all(isfinite(ADC(j(i)-span:j(i)+ticDur+span) ) ) 
        continue
    end
    
    if ~all(ADC(j(i)-span:j(i)+ticDur+span) ~= 2047) 
        continue
    end
    
    if ~all(ADC(j(i)-span:j(i)+ticDur+span) ~= -2048) 
        continue
    end
    
    %% Fit and remove background trend
    
    DACs = DAC(j(i)-span:j(i)+ticDur+span);
    ADCs = ADC(j(i)-span:j(i)+ticDur+span);
    DACAlt1s = DACAlt1(j(i)-span:j(i)+ticDur+span);
    DACAlt2s = DACAlt2(j(i)-span:j(i)+ticDur+span);
    
    x = 1:numel(DACs);
    
    warning('off','stats:statrobustfit:IterationLimit');
    b1=robustfit(x(1:span), ADCs(1:span));
    b2=robustfit(x(span+ticDur+1:end), ADCs(span+ticDur+1:end));
    warning('on','stats:statrobustfit:IterationLimit')

    b(1) = b1(1);
    b(2) = mean([b1(2) b2(2)]);
    
    ADCsdt = ADCs-transpose(b(1)+b(2)*x);
    
    premean = mean(ADCsdt(1:span));
    postmean = mean(ADCsdt(span+ticDur+1:end));
    
    step = postmean-premean;
    
    ADCsdtdm = ADCsdt;
    ADCsdtdm(span+2:end) = ADCsdtdm(span+2:end) - step;
    
    tickArray(tickCount,:) = transpose(ADCsdtdm(span:span+2+ticDur-1));
    stepArray(tickCount,:) = transpose(ADCsdt(span:span+2+ticDur-1));
    timeArray(tickCount) = time(j(i));
    
    tickCount = tickCount + 1;
    
%     figure;
%     subplot(4,1,1);
%     plot(x, DACs)
%     
%     subplot(4,1,2);
%     plot(x, ADCs)
%     
%     subplot(4,1,3);
%     plot(x, ADCsdt)
%     
%     subplot(4,1,4);
%     plot(x, ADCsdtdm)
end

outputArray = struct;
outputArray.ticks = tickArray(isfinite(tickArray(:,1)),:);
outputArray.steps = stepArray(isfinite(stepArray(:,1)),:);
outputArray.time = timeArray(isfinite(timeArray));
outputArray.Tsensor = interp1(hk_time, hk_Tsensor, outputArray.time);
outputArray.Tebox = interp1(hk_time, hk_Tebox, outputArray.time);

fprintf('%s found %d usable ticks of %d possible.\n', titleStr, tickCount, numel(j));
%% Resample timing

hat = 1;

%% Resample temperatures



% if ( numel(tickArray) == ticDur )
%     x = 1:ticDur;
%     figure;
%     plot(x,tickArray);
% end


hat = 1;

end

