function [] = mergeTickFiles(varargin)
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here

default_inputPath = '.';
default_outputPath = '.';
default_searchString = '*.lv1.ticks';

p = inputParser;
p.addParameter('inputPath', default_inputPath, @ischar);
p.addParameter('outputPath', default_outputPath, @ischar);
p.addParameter('searchString', default_searchString, @ischar);
p.parse(varargin{:});

fullSearchString = strcat(p.Results.inputPath,filesep,p.Results.searchString);

fileList = dir( fullSearchString );
numFiles = sum(~[fileList.isdir]);
numDirs = sum([fileList.isdir]);

mergedTicks = struct;

mergedTicks.INXXP2 = struct;
mergedTicks.INXXN2 = struct;
mergedTicks.INXYP2 = struct;
mergedTicks.INXYN2 = struct;
mergedTicks.INXZP2 = struct;
mergedTicks.INXZN2 = struct;
mergedTicks.INYXP2 = struct;
mergedTicks.INYXN2 = struct;
mergedTicks.INYYP2 = struct;
mergedTicks.INYYN2 = struct;
mergedTicks.INYZP2 = struct;
mergedTicks.INYZN2 = struct;
mergedTicks.INZXP2 = struct;
mergedTicks.INZXN2 = struct;
mergedTicks.INZYP2 = struct;
mergedTicks.INZYN2 = struct;
mergedTicks.INZZP2 = struct;
mergedTicks.INZZN2 = struct;
mergedTicks.OUTXXP2 = struct;
mergedTicks.OUTXXN2 = struct;
mergedTicks.OUTXYP2 = struct;
mergedTicks.OUTXYN2 = struct;
mergedTicks.OUTXZP2 = struct;
mergedTicks.OUTXZN2 = struct;
mergedTicks.OUTYXP2 = struct;
mergedTicks.OUTYXN2 = struct;
mergedTicks.OUTYYP2 = struct;
mergedTicks.OUTYYN2 = struct;
mergedTicks.OUTYZP2 = struct;
mergedTicks.OUTYZN2 = struct;
mergedTicks.OUTZXP2 = struct;
mergedTicks.OUTZXN2 = struct;
mergedTicks.OUTZYP2 = struct;
mergedTicks.OUTZYN2 = struct;
mergedTicks.OUTZZP2 = struct;
mergedTicks.OUTZZN2 = struct;
 
fprintf('Found %d files. Excluding %d directories.\n', numFiles, numDirs );

if( numFiles > 0)
    for j = 1:numel(fileList)
       if (~fileList(j).isdir)
            fileName = strcat(p.Results.inputPath,filesep,fileList(j).name);
            fprintf('%s: Starting file: %s\n', mfilename(), fileName);
           
            load(fileName, '-mat');
           
            mergedTicks.INXXP2 = mergeTicks(mergedTicks.INXXP2, ticks.INXXP2);
            mergedTicks.INXXN2 = mergeTicks(mergedTicks.INXXN2, ticks.INXXN2);
            mergedTicks.INXYP2 = mergeTicks(mergedTicks.INXYP2, ticks.INXYP2);
            mergedTicks.INXYN2 = mergeTicks(mergedTicks.INXYN2, ticks.INXYN2);
            mergedTicks.INXZP2 = mergeTicks(mergedTicks.INXZP2, ticks.INXZP2);
            mergedTicks.INXZN2 = mergeTicks(mergedTicks.INXZN2, ticks.INXZN2);
            mergedTicks.INYXP2 = mergeTicks(mergedTicks.INYXP2, ticks.INYXP2);
            mergedTicks.INYXN2 = mergeTicks(mergedTicks.INYXN2, ticks.INYXN2);
            mergedTicks.INYYP2 = mergeTicks(mergedTicks.INYYP2, ticks.INYYP2);
            mergedTicks.INYYN2 = mergeTicks(mergedTicks.INYYN2, ticks.INYYN2);
            mergedTicks.INYZP2 = mergeTicks(mergedTicks.INYZP2, ticks.INYZP2);
            mergedTicks.INYZN2 = mergeTicks(mergedTicks.INYZN2, ticks.INYZN2);
            mergedTicks.INZXP2 = mergeTicks(mergedTicks.INZXP2, ticks.INZXP2);
            mergedTicks.INZXN2 = mergeTicks(mergedTicks.INZXN2, ticks.INZXN2);
            mergedTicks.INZYP2 = mergeTicks(mergedTicks.INZYP2, ticks.INZYP2);
            mergedTicks.INZYN2 = mergeTicks(mergedTicks.INZYN2, ticks.INZYN2);
            mergedTicks.INZZP2 = mergeTicks(mergedTicks.INZZP2, ticks.INZZP2);
            mergedTicks.INZZN2 = mergeTicks(mergedTicks.INZZN2, ticks.INZZN2);
            mergedTicks.OUTXXP2 = mergeTicks(mergedTicks.OUTXXP2, ticks.OUTXXP2);
            mergedTicks.OUTXXN2 = mergeTicks(mergedTicks.OUTXXN2, ticks.OUTXXN2);
            mergedTicks.OUTXYP2 = mergeTicks(mergedTicks.OUTXYP2, ticks.OUTXYP2);
            mergedTicks.OUTXYN2 = mergeTicks(mergedTicks.OUTXYN2, ticks.OUTXYN2);
            mergedTicks.OUTXZP2 = mergeTicks(mergedTicks.OUTXZP2, ticks.OUTXZP2);
            mergedTicks.OUTXZN2 = mergeTicks(mergedTicks.OUTXZN2, ticks.OUTXZN2);
            mergedTicks.OUTYXP2 = mergeTicks(mergedTicks.OUTYXP2, ticks.OUTYXP2);
            mergedTicks.OUTYXN2 = mergeTicks(mergedTicks.OUTYXN2, ticks.OUTYXN2);
            mergedTicks.OUTYYP2 = mergeTicks(mergedTicks.OUTYYP2, ticks.OUTYYP2);
            mergedTicks.OUTYYN2 = mergeTicks(mergedTicks.OUTYYN2, ticks.OUTYYN2);
            mergedTicks.OUTYZP2 = mergeTicks(mergedTicks.OUTYZP2, ticks.OUTYZP2);
            mergedTicks.OUTYZN2 = mergeTicks(mergedTicks.OUTYZN2, ticks.OUTYZN2);
            mergedTicks.OUTZXP2 = mergeTicks(mergedTicks.OUTZXP2, ticks.OUTZXP2);
            mergedTicks.OUTZXN2 = mergeTicks(mergedTicks.OUTZXN2, ticks.OUTZXN2);
            mergedTicks.OUTZYP2 = mergeTicks(mergedTicks.OUTZYP2, ticks.OUTZYP2);
            mergedTicks.OUTZYN2 = mergeTicks(mergedTicks.OUTZYN2, ticks.OUTZYN2);
            mergedTicks.OUTZZP2 = mergeTicks(mergedTicks.OUTZZP2, ticks.OUTZZP2);
            mergedTicks.OUTZZN2 = mergeTicks(mergedTicks.OUTZZN2, ticks.OUTZZN2);
       end
    end
    ticks = mergedTicks;
    outputFileName = strcat(p.Results.outputPath,filesep,'merged.ticks');
    fprintf('Saving merged ticks to ''%s''\n', outputFileName);
    save(outputFileName, 'ticks');
end

end

