function [ logStruct ] = mgfLog( logStruct, message, level )
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here

if ~isfield(logStruct,'reported')
    logStruct.reported = 0;
end

if (strcmpi(level,'debug') || strcmpi(level,'devel') || strcmpi(level,'development'))
    prefix = 'DEBUG:  ';
    curLevel = 1;
elseif (strcmpi(level,'info') || strcmpi(level,'information'))
    prefix = 'INFO:   ';
    curLevel = 2;
elseif (strcmpi(level,'msg') || strcmpi(level,'message'))
    prefix = 'MSG:    ';
    curLevel = 3;
elseif (strcmpi(level,'warn') || strcmpi(level,'warning'))
    prefix = 'WARN:   ';
    curLevel = 4;
elseif (strcmpi(level,'error') )
    prefix = 'ERROR:  ';
    curLevel = 5;
else
    prefix = 'UNDEF:  ';
    curLevel = 6;
end

   

messageToLog = sprintf('%s%s\n',prefix,deblank(message));

logStruct.text = [logStruct.text messageToLog];

if (curLevel >= logStruct.level)
    if (logStruct.reported == 0)
        fprintf('MGFLOG: First report from %s processing %s.\n', logStruct.callingFileName, logStruct.fileName);
        logStruct.reported = 1;
    end
    
    fprintf('%s', messageToLog);
end

end

