function [ logStruct ] = mgfLogInit( logStruct, callingFileName, parser, fileName, suffix, level )
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

if isempty(logStruct)
    logStruct = struct;
end

if ~isfield(logStruct,'fileName')
    logStruct.fileName='';
end

if ~isfield(logStruct,'text')
    logStruct.text = "";
end

if ~isfield(logStruct,'level')
    logStruct.level = 0;
end


if isempty(level)
    logStruct.level = logStruct.level;
elseif (strcmpi(level,'debug') || strcmpi(level,'devel') || strcmpi(level,'development'))
    logStruct.level = 1;
elseif (strcmpi(level,'info') || strcmpi(level,'information'))
    logStruct.level = 2;
elseif (strcmpi(level,'msg') || strcmpi(level,'message'))
    logStruct.level = 3;
elseif (strcmpi(level,'warn') || strcmpi(level,'warning'))
    logStruct.level = 4;
elseif (strcmpi(level,'debug') || strcmpi(level,'debugging'))
    logStruct.level = 5;
else
    logStruct.level = 0;
end

if ~isempty(fileName)
    logStruct.fileName = strcat(fileName,suffix);
end


logStruct.callingFileName = callingFileName;

logStruct = mgfLog(logStruct, sprintf('Time: %s\n', datetime()), 'info');
logStruct = mgfLog(logStruct, sprintf('Logging started by ''%s''\n', callingFileName), 'info');
logStruct = mgfLog(logStruct, sprintf('Filename: ''%s''\n', fileName), 'info');
logStruct = mgfLog(logStruct, sprintf('Suffix:   ''%s''\n', suffix), 'info');
logStruct = mgfLog(logStruct, sprintf('Level:    ''%s''\n', level), 'info');
logStruct = mgfLog(logStruct, sprintf('Hostname: ''%s''\n', char(java.net.InetAddress.getLocalHost.getHostName) ), 'info');
logStruct = mgfLog(logStruct, sprintf('Username: ''%s''\n', char(java.lang.System.getProperty('user.name')) ), 'info');
logStruct = mgfLog(logStruct, sprintf('mgfLog print threshold set to %d.\n', logStruct.level), 'info');

if ~isempty(parser)
    logStruct = mgfLog(logStruct, sprintf('Commandline parser containes %d elements:\n',numel(fieldnames(parser.Results))), 'info');

    for i = 1:numel(fieldnames(parser.Results))
        logStruct = mgfLog(logStruct, sprintf(' Parameter ''%s'' contained ''%s''\n', ...
            char(parser.Parameters(i)), getfield(parser.Results,char(parser.Parameters(i))) ), 'info');
    end
end

logFileName = strcat( logStruct.fileName, '.log');

if isfile(strcat( logStruct.fileName, '.log'))
    logStruct = mgfLog(logStruct, sprintf('Deleting existing logfile: ''%s''\n', logFileName), 'info' );
    delete(logFileName);
end

end

