function [ retVal, tStart, tEnd, dataLevel, logStruct ] = mgfParsefileName( file, logStruct )
%UNTITLED3 Summary of this function goes here
%   Detailed explanation goes here

retVal = 0;
logStruct = mgfLogInit( logStruct, mfilename(), [], file, [], [] );

logStruct = mgfLog(logStruct, sprintf('Parsing ''%s''.\n',file), 'info');

[filePath,fileName,fileExt] = fileparts(file);

% Check first three characters to ensure this is an MGF file
if ~strcmp(extractBetween(strcat(fileName,fileExt),1,3),'MGF')
    logStruct = mgfLog(logStruct, sprintf('File ''%s'' is not an MGF file.\n',strcat(fileName,fileExt)), 'error');
    retVal = -1;
    tStart = NaT;
    tEnd = NaT;
    dataLevel = nan;
    return;
end

% Parse data level
if strcmp(fileExt,'.lv0')
    dataLevel = 0;
elseif strcmp(fileExt,'.lv1')
    dataLevel = 1;
elseif strcmp(fileExt,'.lv2')
    dataLevel = 2;
elseif strcmp(fileExt,'.lv3')
    dataLevel = 3;
elseif strcmp(fileExt,'.lv4')
    dataLevel = 4;
elseif strcmp(fileExt,'.bin')
    dataLevel = 99;
else 
    dataLevel = -1;
    retVal = -1;
end

if (dataLevel == 99)
    logStruct = mgfLog(logStruct, 'Extension ''.bin'' suggests laboratory data with no timestamp.', 'warn' );
end

logStruct = mgfLog(logStruct, sprintf('File extension suggests Level %d data.\n', dataLevel), 'info' );
    
% Parse start and end times
parsedYY    = str2double(extractBetween(fileName,05,08));
parsedMM    = str2double(extractBetween(fileName,09,10));
parsedDD    = str2double(extractBetween(fileName,11,12));

parsedSHH   = str2double(extractBetween(fileName,14,15));
parsedSMI   = str2double(extractBetween(fileName,16,17));
parsedSSS   = str2double(extractBetween(fileName,18,19));

parsedFHH   = str2double(extractBetween(fileName,21,22));
parsedFMI   = str2double(extractBetween(fileName,23,24));
parsedFSS   = str2double(extractBetween(fileName,25,26));

tStart      = datetime(parsedYY, parsedMM, parsedDD, parsedSHH, parsedSMI, parsedSSS);
tEnd        = datetime(parsedYY, parsedMM, parsedDD, parsedFHH, parsedFMI, parsedFSS);

logStruct = mgfLog(logStruct, sprintf('fileName suggests times from %s to %s.\n', datestr(tStart), datestr(tEnd) ), 'info');



end

