function [ output_args ] = mgf_Level2( varargin )
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here

default_inputPath = '.';
default_outputPath = '.';
default_searchString = '*.lv1';
detault_detickPlot = 0;
default_extractTicks = 0;
default_disableDetick = 0;
default_forceSimpleDetick = 0;
default_truncateToReal = 1;

p = inputParser;
p.addParameter('inputPath', default_inputPath, @ischar);
p.addParameter('outputPath', default_outputPath, @ischar);
p.addParameter('searchString', default_searchString, @ischar);
p.addParameter('detickPlot', detault_detickPlot, @isnumeric);
p.addParameter('extractTicks', default_extractTicks, @isnumeric);
p.addParameter('disableDetick', default_disableDetick, @isnumeric);
p.addParameter('forceSimpleDetick', default_forceSimpleDetick, @isnumeric);
p.addParameter('truncateToReal', default_truncateToReal, @isnumeric);
p.parse(varargin{:});


logStruct_temp = struct;
logStruct_temp = mgfLogInit( logStruct_temp, mfilename(), p, '', '', 'info' );

fullSearchString = strcat(p.Results.inputPath,filesep,p.Results.searchString);

logStruct_temp = mgfLog(logStruct_temp, sprintf('Checking %s\n', fullSearchString),'msg');

fileList = dir( fullSearchString );
numFiles = sum(~[fileList.isdir]);
numDirs = sum([fileList.isdir]);

logStruct_temp = mgfLog(logStruct_temp, sprintf('Found %d files. Excluding %d directories.\n', numFiles, numDirs ), 'msg');

if( numFiles > 0)
    if (p.Results.detickPlot )
        for j = 1:numel(fileList)
           if (~fileList(j).isdir)
               fileName = strcat(p.Results.inputPath,filesep,fileList(j).name);
               logStruct_for = mgfLog(logStruct_temp, sprintf('%s: Starting file ''%s''\n', mfilename(), fileName), 'msg' );
               
               try
                  mgf_Level2_par(fileName, p, logStruct_for );
               catch EM
                 logStruct_for = mgfLog(logStruct_temp, sprintf('%s: Caught error %s with message %s.\n', mfilename(), EM.identifier, EM.message), 'ERROR');
                 logStruct_for.fileName = fileName;
                 mgfLogDump( logStruct_for );
               end
           end
        end
    else
        parfor j = 1:numel(fileList)
           if (~fileList(j).isdir)
            fileName = strcat(p.Results.inputPath,filesep,fileList(j).name);
            logStruct_parfor = mgfLog(logStruct_temp, sprintf('%s: Starting file ''%s''\n', mfilename(), fileName), 'msg' );
            
            try
                mgf_Level2_par(fileName, p, logStruct_parfor );
            catch EM
                logStruct_parfor = mgfLog(logStruct_temp, sprintf('%s: Caught error %s with message %s.\n', mfilename(), EM.identifier, EM.message), 'ERROR');
                logStruct_parfor.fileName = fileName;
                mgfLogDump( logStruct_parfor );
            end
            
           end
        end
    end
end

end
