function [ output_args ] = mgf_Level3( varargin )
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here

default_inputPath = '.';
default_outputPath = '.';
default_searchString = '*.lv2';
default_disableInterpolate = 0;

p = inputParser;
p.addParameter('inputPath', default_inputPath, @ischar);
p.addParameter('outputPath', default_outputPath, @ischar);
p.addParameter('searchString', default_searchString, @ischar);
p.addParameter('disableInterpolate', default_disableInterpolate, @isnumeric);

p.parse(varargin{:});

logStruct_temp = struct;
logStruct_temp = mgfLogInit( logStruct_temp, mfilename(), p, '', '', 'msg' );

fullSearchString = strcat(p.Results.inputPath,filesep,p.Results.searchString);

logStruct_temp = mgfLog(logStruct_temp, sprintf('Checking %s\n', fullSearchString), 'msg');


fileList = dir( fullSearchString );
numFiles = sum(~[fileList.isdir]);
numDirs = sum([fileList.isdir]);

logStruct_temp = mgfLog(logStruct_temp, sprintf('Found %d files. Excluding %d directories.\n', numFiles, numDirs ), 'msg');

if( numFiles > 0)
    parfor j = 1:numel(fileList)
        if (~fileList(j).isdir)
           fileName = strcat(p.Results.inputPath,filesep,fileList(j).name);
           logStruct_for = mgfLog(logStruct_temp, sprintf('%s: Starting file ''%s''\n', mfilename(), fileName), 'msg' );

           try
              mgf_Level3_par(fileName, p, logStruct_for );
           catch EM
             logStruct_for = mgfLog(logStruct_temp, sprintf('%s: Caught error %s with message %s.\n', mfilename(), EM.identifier, EM.message), 'ERROR');
             logStruct_for.fileName = fileName;
             mgfLogDump( logStruct_for );
           end
        end
    end
end

end
