function [] = mgf_Level3_par(fileName, p, logStruct_temp)
%UNTITLED3 Summary of this function goes here
%   Detailed explanation goes here
defs = mgfDefs();
curLevel = 2;

%% Init the log infrastructure

if isempty(logStruct_temp)
    logStruct_temp = struct;
end

logStruct_temp = mgfLogInit( logStruct_temp, mfilename(), p, fileName, '', 'msg' );

[ retVal, tStart, tEnd, dataLevel, logStruct_temp ] = mgfParseFilename( fileName, logStruct_temp );

if retVal
   logStruct_temp = mgfLog(logStruct_temp, sprintf('mgfParseFilename returned %d.', retVal), 'error');
   mgfLogDump(logStruct_temp);
   return;
end

load(fileName,'-mat');

logStruct.text = [logStruct.text logStruct_temp.text];
logStruct.fileName = logStruct_temp.fileName;
logStruct.callingFileName = logStruct_temp.callingFileName;
logStruct.level = logStruct_temp.level;

%% Interpolate to fill data

if (p.Results.disableInterpolate == 0)
    B_Inboard(isnan(B_Inboard(:,1)),1) = interp1(t_fit(~isnan(B_Inboard(:,1))),B_Inboard(~isnan(B_Inboard(:,1)),1),t_fit(isnan(B_Inboard(:,1))),'spline');
    B_Inboard(isnan(B_Inboard(:,2)),2) = interp1(t_fit(~isnan(B_Inboard(:,2))),B_Inboard(~isnan(B_Inboard(:,2)),2),t_fit(isnan(B_Inboard(:,2))),'spline');
    B_Inboard(isnan(B_Inboard(:,3)),3) = interp1(t_fit(~isnan(B_Inboard(:,3))),B_Inboard(~isnan(B_Inboard(:,3)),3),t_fit(isnan(B_Inboard(:,3))),'spline');

    B_Outboard(isnan(B_Outboard(:,1)),1) = interp1(t_fit(~isnan(B_Outboard(:,1))),B_Outboard(~isnan(B_Outboard(:,1)),1),t_fit(isnan(B_Outboard(:,1))),'spline');
    B_Outboard(isnan(B_Outboard(:,2)),2) = interp1(t_fit(~isnan(B_Outboard(:,2))),B_Outboard(~isnan(B_Outboard(:,2)),2),t_fit(isnan(B_Outboard(:,2))),'spline');
    B_Outboard(isnan(B_Outboard(:,3)),3) = interp1(t_fit(~isnan(B_Outboard(:,3))),B_Outboard(~isnan(B_Outboard(:,3)),3),t_fit(isnan(B_Outboard(:,3))),'spline');
end


%% Merge the two magnetometer streams.

% FIXME - Currently just using internal.

B = B_Inboard;
t = t_fit;


%% Fill in the metadata

metadata.Level3 = struct;
metadata.Level3.StartTime = min(t_fit);
metadata.Level3.EndTime =  max(t_fit);

%% Generate output filename

outputFileName = genFileName( metadata.Level3.StartTime, metadata.Level3.EndTime, curLevel+1, defs.Version );

outputFileNameFull = strcat(p.Results.outputPath, filesep, outputFileName);

%% Save output file

logStruct = mgfLog(logStruct, sprintf("Saving output file: %s\n", outputFileNameFull), 'info');
save(outputFileNameFull, 't', 'B', 'metadata', 'logStruct');

end

