function [] = mgf_detickPlot(B, dacx, dacy, dacz, titleStr)
%UNTITLED7 Summary of this function goes here
%   Detailed explanation goes here
smoothInterval = 160;

index = 1:numel(B);

figHandle = figure();

dB = B - nanfastsmooth(B,smoothInterval);

p1 = subplot(5,1,1);
plot(index,dB);
p1.XTickLabel = [];
ylabel('B');

title(titleStr);

p2 = subplot(5,1,2);
overlap = 32;
nfft = 128;
Fs = 160;
B(isnan(B)) = interp1(index(~isnan(B)),B(~isnan(B)),index(isnan(B)),'spline');
[F, T, PSD, PS, LSD, LS, ENBW ] = quantSpectrogram(B,index,nfft,overlap,Fs);
surf(T,F,10*log10(sqrt(abs(transpose(PSD)))), 'linestyle', 'none');
view(0,90);
xlim( [min(T) max(T)] );
ylim( [min(F) max(F)] );
grid on;
ylabel('Frequency (Hz)');
p1.XTickLabel = [];

p3 = subplot(5,1,3);
plot(index, dacx,'r');
p2.XTickLabel = [];
ylabel('DAC X');

p4 = subplot(5,1,4);
plot(index, dacy,'b');
p3.XTickLabel = [];
ylabel('DAC Y');

p5 = subplot(5,1,5);
plot(index, dacz,'g');
ylabel('DAC Z');

linkaxes([p1 p2 p3 p4 p5], 'x')

end

