function [ PSD, PS, LSD, LS, f, ENBW ] = quantSpectra( timeseries, Fs, NFFT, winType )
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

j=0:1:NFFT-1;
z=2*pi*j/NFFT;

if strcmp(winType,'hann')
    window = hann(NFFT);
    ENBW = 1.5000*Fs/NFFT;
elseif strcmp(winType,'bh92')
    window = 0.35875 - 0.48829*cos(z) + 0.14128*cos(2*z) - 0.01168*cos(3*z);
    ENBW = 2.0044*Fs/NFFT;
elseif strcmp(winType,'hft95')
    window = 1 - 1.9383379*cos(z) + 1.3045202*cos(2*z) - 0.4028270*cos(3*z) + 0.0350665*cos(4*z);
    ENBW = 3.8112*Fs/NFFT;
elseif strcmp(winType,'hft248')
    window = 1 - 1.985844164102*cos(z) + 1.791176438506*cos(2*z) - 1.282075284005*cos(3*z) + 0.667777530266*cos(4*z) - 0.240160796576*cos(5*z) + 0.056656381764*cos(6*z) - 0.008134974479*cos(7*z) + 0.000624544650*cos(8*z) - 0.000019808998*cos(9*z) + 0.000000132974*cos(10*z);
    ENBW = 5.6512*Fs/NFFT;
else
    disp('Select a windown function: hann, bh92, hft95, hft248');
end

detrendedTimeSeries = detrend(timeseries);

[PSD,f] = pwelch(detrendedTimeSeries,window,round(3*NFFT/4),NFFT,Fs,'onesided');


PS = PSD*ENBW;

LSD = sqrt(PSD);

LS = sqrt(PS);

%P = P(3:end);
%f = f(3:end);

end
