function [qi] = slerp_quaternion(Attitude,t_fit)
%Takes an initial time array, initial quaternion array in the Attitude
%structure along with a desired time array and interpolates the quaternions
%using Spherical LinEar inteRPolation (SLERP).
%
%Created by Robert Broadfoot 06/25/2019
qi = zeros(numel(t_fit),4);
count = 1;
Time = Attitude.Time;
for s = 1:numel(Attitude.Quaternion(:,1))-1
    q1 = Attitude.Quaternion(s,:);
    q1 = q1/norm(q1);
    q1m = [q1(1) -q1(2) -q1(3) -q1(4)];
    q2 = Attitude.Quaternion(s+1,:);  
    q2=  q2/norm(q2);
    dot_p = dot(q1,q2);
    if dot_p < 0
        q2 = -q2;
    end
    if abs(Time(s+1).Second-Time(s).Second) ~=1&&(60+Time(s+1).Second)-Time(s).Second ~=1
       
        nummin = abs(Time(s+1).Minute-Time(s).Minute);
        numsec = abs(Time(s+1).Second-Time(s).Second);
        ttl = nummin*60+numsec;
        t_vec = find(ge(t_fit,Time(s))&t_fit<Time(s+1));
        numsecdif = 0;
        t_array(1) = numsecdif+(t_fit(t_vec(1)).Second-floor(t_fit(t_vec(1)).Second));
        for i = 2:numel(t_vec)

            if floor(t_fit(t_vec(i)).Second)-floor(t_fit(t_vec(i-1)).Second)==1
                numsecdif = numsecdif+1;
                
            end
            if t_fit(t_vec(i)).Minute-t_fit(t_vec(i-1)).Minute==1
                 
                numsecdif = numsecdif+1;
            end
            t_array(i) = (numsecdif+(t_fit(t_vec(i)).Second-floor(t_fit(t_vec(i)).Second)))/ttl;
        end 
        
    else
        t_vec = find(ge(t_fit,Time(s))&t_fit<Time(s+1));
        t_array = t_fit(t_vec).Second-floor(t_fit(t_vec).Second);
    end
    qr = [q2(1)*q1m(1)-q2(2)*q1m(2)-q2(3)*q1m(3)-q2(4)*q1m(4) q2(1)*q1m(2)+q2(2)*q1m(1)-q2(3)*q1m(4)+q2(4)*q1m(3)... 
        q2(1)*q1m(3)+q2(2)*q1m(4)+q2(3)*q1m(1)-q2(4)*q1m(2) q2(1)*q1m(4)-q2(2)*q1m(3)+q2(3)*q1m(2)+q2(4)*q1m(1)];
    qr = qr/norm(qr);
    r = [qr(2) qr(3) qr(4)];    
    for j = 1:numel(t_array)
        qln = [log(norm(qr)),(r/norm(r))*acos(qr(1)/norm(qr))];
        qln = t_array(j)*qln;
        qlnv = [qln(2) qln(3) qln(4)];
        qex = exp(qln(1))*[cos(norm(qlnv)),(qlnv/norm(qlnv))*sin(norm(qlnv))];
        qi(count,:) = [qex(1)*q1(1)-qex(2)*q1(2)-qex(3)*q1(3)-qex(4)*q1(4) qex(1)*q1(2)+qex(2)*q1(1)-qex(3)*q1(4)+qex(4)*q1(3)... 
        qex(1)*q1(3)+qex(2)*q1(4)+qex(3)*q1(1)-qex(4)*q1(2) qex(1)*q1(4)-qex(2)*q1(3)+qex(3)*q1(2)+qex(4)*q1(1)];
        

        count = count+1;
    end
end


end