function [ t, magData, t_hk, hk_aux, ppsOffsets, logStruct, errorCode ] = unRollPackets( Packet, logStruct )
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

[ defs ] = mgfDefs();

errorCode = 0;

logStruct = mgfLogInit( logStruct, mfilename(), [], [], '', [] );

maxObsLength = ceil(seconds(Packet(end).Time - Packet(1).Time))+1;

t = NaT(maxObsLength*160,1);
magData = NaN(maxObsLength*160,6);
ppsOffsets = NaN(maxObsLength*160,1);

t_hk = NaT(maxObsLength,1);
hk_aux = NaN(maxObsLength,40);

i = 1; % To step through the array of packets
j = i; % To step through the new array of samples
prevSequence = NaN;
prevTime = NaT;
while ( i < numel(Packet) )
    
    if (i > 1)
        if (mod(Packet(i).Sequence - prevSequence,256) ~= 1)
            logStruct = mgfLog(logStruct, sprintf('Sequence counters went from %d to %d from %s to %s.\n', prevSequence, Packet(i).Sequence, datestr(prevTime), Packet(i).Time), 'warn');
            
            timeJump = round(seconds(Packet(i).Time - prevTime)) - 1;
            seqJump = Packet(i).Sequence - prevSequence - 1;
            
            if ( mod(timeJump,256) ~= mod(seqJump,256) )
                logStruct = mgfLog(logStruct, sprintf('Dropout infered from spacecraf time (%d) does not match that infered from sequence counters (%d). Terminating.\n', timeJump, seqJump), 'error');
                errorCode = -1;
                return
            else
                logStruct = mgfLog(logStruct, sprintf("Padding %ds of NaN starting at %s.\n", timeJump, datestr(Packet(i).Time)), 'warn');
                j = j + timeJump;
            end
            
        end
        
    end
    prevSequence = Packet(i).Sequence;
    prevTime = Packet(i).Time;
   
    
    index = (j-1)*160+1;
    indexRange = (j-1)*160+1:(j)*160;

    DACXFull = NaN(160,1);
    DACXFull(1:4:end)=Packet(i).DACX;
    DACXFull(2:4:end)=Packet(i).DACX;
    DACXFull(3:4:end)=Packet(i).DACX;
    DACXFull(4:4:end)=Packet(i).DACX;

    DACYFull = NaN(160,1);
    DACYFull(1:4:end)=Packet(i).DACY;
    DACYFull(2:4:end)=Packet(i).DACY;
    DACYFull(3:4:end)=Packet(i).DACY;
    DACYFull(4:4:end)=Packet(i).DACY;

    DACZFull = NaN(160,1);
    DACZFull(1:4:end)=Packet(i).DACZ;
    DACZFull(2:4:end)=Packet(i).DACZ;
    DACZFull(3:4:end)=Packet(i).DACZ;
    DACZFull(4:4:end)=Packet(i).DACZ;
   
    t(index) = Packet(i).Time;
    ppsOffsets(index) = Packet(i).Offset;
    magData(indexRange,1) = DACXFull;
    magData(indexRange,2) = DACYFull;
    magData(indexRange,3) = DACZFull;
    magData(indexRange,4) = Packet(i).ADCX;
    magData(indexRange,5) = Packet(i).ADCY;
    magData(indexRange,6) = Packet(i).ADCZ;
    
    t_hk(j) = Packet(i).Time;
    hk_aux(j,:) = Packet(i).Aux;
    
    i = i + 1;
    j = j + 1;
end

t = t(1:max(indexRange));
magData = magData(1:max(indexRange),:);

t_hk = t_hk(1:j-1);
hk_aux = hk_aux(1:j-1,:);


end

