function [ packet ] = unpackLV0DatePacket( lv0Packet )
%UNTITLED5 Summary of this function goes here
%   Detailed explanation goes here

defs = mgfDefs();

packet=defs.nullpacket;

packet.Time =  parseCCSDSTime( lv0Packet.CCSDSTime);

packet.BoardID = lv0Packet.raw(1+defs.oBoardId);

packet.Offset = 256*256*lv0Packet.raw(1+defs.oMSBOffset) ...
    + 256*lv0Packet.raw(1+defs.oMIDOffset) ... 
    + lv0Packet.raw(1+defs.oLSBOffset);

packet.Sequence = lv0Packet.raw(1+defs.oLDMeas);

packet.PacketType = lv0Packet.raw(1+defs.oPKTTYPE);

packet.Version = [ lv0Packet.raw(1+defs.oMAJVER) lv0Packet.raw(1+defs.oMINVER) lv0Packet.raw(1+defs.oREVVER)];

DACXHighNibble = bitand(uint8(lv0Packet.raw(defs.iDACXHighNibble)),hex2dec('0f'));
DACYHighWord = uint8(lv0Packet.raw(defs.iDACYHighNibble));
DACZHighNibble = bitand(uint8(lv0Packet.raw(defs.iDACZHighNibble)),hex2dec('0f'));

DACXLowWord    = uint8(lv0Packet.raw(defs.iDACXLowWord));
DACYLowNibble  = bitand(uint8(lv0Packet.raw(defs.iDACYLowWord)),hex2dec('f0'));
DACZLowWord    = uint8(lv0Packet.raw(defs.iDACZLowWord));

DACX = typecast(bitor(bitsll(uint16(DACXHighNibble),12),bitsll(uint16(DACXLowWord),4)),'int16')/16;
DACY = typecast(bitor(bitsll(uint16(DACYHighWord),8),uint16(DACYLowNibble)),'int16')/16;
DACZ = typecast(bitor(bitsll(uint16(DACZHighNibble),12),bitsll(uint16(DACZLowWord),4)),'int16')/16;

ADCXHighNibble = uint8(lv0Packet.raw(defs.iADCXHighNibble));
ADCXMidNibble = uint8(lv0Packet.raw(defs.iADCXMidNibble));
ADCXLowNibble  = uint8(lv0Packet.raw(defs.iADCXLowNibble));

ADCYHighNibble = uint8(lv0Packet.raw(defs.iADCYHighNibble));
ADCYMidNibble = uint8(lv0Packet.raw(defs.iADCYMidNibble));
ADCYLowNibble  = uint8(lv0Packet.raw(defs.iADCYLowNibble));

ADCZHighNibble = uint8(lv0Packet.raw(defs.iADCZHighNibble));
ADCZMidNibble = uint8(lv0Packet.raw(defs.iADCZMidNibble));
ADCZLowNibble  = uint8(lv0Packet.raw(defs.iADCZLowNibble));


ADCXHighNibble(1:2:end) = bitsrl(ADCXHighNibble(1:2:end),4);
ADCXHighNibble(2:2:end) = bitand(ADCXHighNibble(2:2:end),hex2dec('0f'));
ADCXMidNibble(1:2:end) = bitand(ADCXMidNibble(1:2:end),hex2dec('0f'));
ADCXMidNibble(2:2:end) = bitsrl(ADCXMidNibble(2:2:end),4);
ADCXLowNibble(1:2:end) = bitsrl(ADCXLowNibble(1:2:end),4);
ADCXLowNibble(2:2:end) = bitand(ADCXLowNibble(2:2:end),hex2dec('0f'));
ADCX = typecast((bitor(bitsll(uint16(ADCXHighNibble),12),bitsll(uint16(bitor(bitsll(ADCXMidNibble,4),ADCXLowNibble)),4))),'int16')/16;

ADCYHighNibble(1:2:end) = bitand(ADCYHighNibble(1:2:end),hex2dec('0f'));
ADCYHighNibble(2:2:end) = bitsrl(ADCYHighNibble(2:2:end),4);
ADCYMidNibble(1:2:end) = bitsrl(ADCYMidNibble(1:2:end),4);
ADCYMidNibble(2:2:end) = bitand(ADCYMidNibble(2:2:end),hex2dec('0f'));
ADCYLowNibble(1:2:end) = bitand(ADCYLowNibble(1:2:end),hex2dec('0f'));
ADCYLowNibble(2:2:end) = bitsrl(ADCYLowNibble(2:2:end),4);
ADCY = typecast((bitor(bitsll(uint16(ADCYHighNibble),12),bitsll(uint16(bitor(bitsll(ADCYMidNibble,4),ADCYLowNibble)),4))),'int16')/16;


ADCZHighNibble(1:2:end) = bitsrl(ADCZHighNibble(1:2:end),4);
ADCZHighNibble(2:2:end) = bitand(ADCZHighNibble(2:2:end),hex2dec('0f'));
ADCZMidNibble(1:2:end) = bitand(ADCZMidNibble(1:2:end),hex2dec('0f'));
ADCZMidNibble(2:2:end) = bitsrl(ADCZMidNibble(2:2:end),4);
ADCZLowNibble(1:2:end) = bitsrl(ADCZLowNibble(1:2:end),4);
ADCZLowNibble(2:2:end) = bitand(ADCZLowNibble(2:2:end),hex2dec('0f'));
ADCZ = typecast((bitor(bitsll(uint16(ADCZHighNibble),12),bitsll(uint16(bitor(bitsll(ADCZMidNibble,4),ADCZLowNibble)),4))),'int16')/16;

packet.DACX = double(DACX);
packet.DACY = double(DACY);
packet.DACZ = double(DACZ);

packet.ADCX = double(ADCX);
packet.ADCY = double(ADCY);
packet.ADCZ = double(ADCZ);

Aux(40,2)=NaN;
for i=1:40
    Aux(i,:) = lv0Packet.raw(defs.cAuxSpacing*(i-1)+defs.oAux1:defs.cAuxSpacing*(i-1)+defs.oAux1+1);
end

packet.Aux(defs.iAux8b) = double(uint8(Aux(defs.iAux8b,1)));
packet.Aux(defs.iAux12b) = double(bitor(bitsll(uint16(Aux(defs.iAux12b,1)),4),uint16(bitsrl(uint8(Aux(defs.iAux12b,2)),4))));


hat = 1;
end

